// Playground - noun: a place where people can play

import UIKit
import Foundation

// Definition einer Zeichenkette in Swift
// Der Datentyp müsste hier nicht angegeben werden
var text:String = "Hallo, Welt!"

// So sah die Definition einer Zeichenkette
// in Objective-C aus
// NSString *text = @"Hallo Welt";

var value = "50"
var newValue = value + "50"

var firstName = "Georg"
var lastName = "Freitag"
var fullName = "Mein Name ist " + firstName + " " + lastName + "."

var interpolatedFullName
= "Mein Name ist \(firstName) \(lastName)."

var price = 1.339
var liter = 8.5
var total = "\(liter) Liter zu \(price) kosten \(price * liter) €"

var totalFormatted
= String(format: "%.2f Liter zu %.2f kosten %.2f €", liter, price, liter * price)

var personName = "Max Müller"
var age = 54
var description
= String(format: "Mein Name ist %@. Ich bin %i Jahre alt", personName, age)

// Enthält die Zeichenkette ein Zeichen?
var empty = fullName.isEmpty

// Wieviele Zeichen enthält der String?
var charCount = fullName.characters.count


// Vergleich von Zeichenketten auf Gleichheit
var aFirstName = "Petra"
var aLastName = "Schubert"

if aFirstName + " " + aLastName == "Petra Schubert"
{
    print("Die Zeichenketten sind gleich")
}
    else
{
    print("Die Zeichenketten sind ungleich")
}


var value1 = "Dortmund"
var value2 = "Bochum"

// Ein Vergleichsergebnis
var comparisonResult:NSComparisonResult
= value1.compare(value2, options: NSStringCompareOptions.CaseInsensitiveSearch)

if comparisonResult == NSComparisonResult.OrderedSame
{
    print("Die Zeichenketten sind gleich")
}
    else if comparisonResult == NSComparisonResult.OrderedAscending
{
    print("\(value1) kommt vor \(value2).")
}
    else if comparisonResult == NSComparisonResult.OrderedDescending
{
    print("\(value2) kommt vor \(value1).")
}

var city1 = "Frankfurt"
var city2 = "frankFurt"

var city1Upper = city1.uppercaseString;
var city2Upper = city2.uppercaseString;

if city1Upper == city2Upper
{
    print("Die Zeichenketten sind gleich")
}
else
{
    print("Die Zeichenketten sind unterschiedlich")
}

var city = "Hamburg"
var search = "burg"

if city.rangeOfString(search) != nil
{
    print("Die gesuchte Zeichenfolge ist enthalten")
}

var range = city.rangeOfString(search, options: NSStringCompareOptions.CaseInsensitiveSearch)

if let validRange = range
{
    print("Startindex: \(validRange.startIndex)")
    print("Endindex: \(validRange.endIndex)")
}
else
{
    print("Die gesuchte Zeichenfolge ist nicht enthalten")
}


var greetings
= "Hallo Objective-C-Entwickler!"
greetings = greetings.stringByReplacingOccurrencesOfString("Objective-C", withString: "Swift")
greetings = greetings.stringByReplacingOccurrencesOfString("hallo", withString: "Guten Tag", options: NSStringCompareOptions.CaseInsensitiveSearch)

var whitespaceString = "   Mein Name is Andreas  "
var normalString = whitespaceString.stringByTrimmingCharactersInSet(NSCharacterSet.whitespaceAndNewlineCharacterSet())

var whitespaceAmount = "Der Rechnungsbetrag ist: 199,44"
var normalAmount = whitespaceAmount.stringByTrimmingCharactersInSet(NSCharacterSet.decimalDigitCharacterSet().invertedSet)

var numericStringValue = "223"
var numericIntValue:Int? = Int(numericStringValue)


// Der urspüngliche Werte als Zeichenkette
var numberValue:String = "120,3456"

// Einen NSNumberFormatter erzeugen
var formatter = NSNumberFormatter()
formatter.locale = NSLocale(localeIdentifier: "de_DE")

// Minmal und maximal zwei Nachkommastellen
formatter.minimumFractionDigits = 2
formatter.maximumFractionDigits = 2

// Ein NSNumber-Typ als Optional denn die 
// umwandlung kann fehlschlagen. 
// Die explizite Angabe des Typen ist nicht zwingend weil
// numberFromString immer einen Optional zurück gibt
var number:NSNumber? = formatter.numberFromString(numberValue)

if let validNumber = number
{
    var newNumberValue = formatter.stringFromNumber(validNumber)
}



